clear;
addpath('..\functions');





%load state level real income per cap
load('realincome')
statex=realincomepercap;


%load employment
[empx,names2x]=xlsread('empsaQ.xls');
empx=empx(5:end,:);
empx=empx(1:end,:);

%load annual expenditure
load('G_MFVAR','gov_exp_pc')
gov_exp_pc=gov_exp_pc(1:end,:);

%load US wide data
tmp=xlsread('FederalFiscalData.xls');
GS=tmp(:,7); %Fed spending
GS=GS(5:end,:);
TAX=tmp(:,end); %federal taxes
TAX=TAX(5:end,:);
tmp=xlsread('.\raw\gdpc96.xls');
GDP=tmp(5:end,:);
tmp=xlsread('.\raw\gdpdeflator1.xls');
GDPDEF=tmp;
tmp=xlsread('.\raw\tbill.xls');
TBILL=tmp(5:end,:);
US=[log(GS)*100 log(TAX)*100 log(GDP)*100 log(GDPDEF)*100 TBILL];



dataS=cell(50,1); %panel data
info=cell(50,1);

for j=1:cols(statex)
    tmp1=[log(gov_exp_pc(:,j))*100 (log(statex(:,j)))*100 (log(empx(:,j)))*100];
 

    
dat=[tmp1 US];
Toriginal=rows(dat);
idnan=isnan(dat(:,1));
dat(idnan,1)=0;
datp=packr([dat idnan]);
Tnew=rows(datp);

idnan=datp(:,end);
dat=datp(:,1:end-1);
dat(idnan==1,1)=nan;
dataS{j}=dat;
info{j}=[Toriginal Tnew];
end
save('data_for_MFVAR','dataS','info');    
    