clear;
addpath('..\functions');





%load state level real income per cap
load('realincome')
statex=realincomepercap(9:end,:);


%load employment
[empx,names2x]=xlsread('empsaQ.xls');
empx=empx(5:end,:);
empx=empx(9:end,:);

%load annual expenditure
load('.\G_MFVAR','gov_exp_pc')
gov_exp_pc=gov_exp_pc(9:end,:);
%load starting values 
load('.\Estimated_spending_data\dataG')
dataG=dataout(9:end,:);

%load US wide data
tmp=xlsread('FederalFiscalData.xls');
GS=tmp(:,7); %Fed spending
GS=GS(13:end,:);
TAX=tmp(:,end); %federal taxes
TAX=TAX(13:end,:);
tmp=xlsread('.\raw\gdpc96.xls'); %GDP
GDP=tmp(13:end,:);
tmp=xlsread('.\raw\gdpdeflator1.xls');%GDP DEF
GDPDEF=tmp(9:end);
tmp=xlsread('.\raw\tbill.xls');%TBILL
TBILL=tmp(13:end,:);
tmp=xlsread('.\raw\BAA.xls');%BAA spread
BAA=tmp(13:end,3);


US=[log(GS)*100 log(TAX)*100 log(GDP)*100 log(GDPDEF) TBILL BAA];  %exogenous variables in the VAR
US=US(5:end,:);



%arrange panel
index=[]; %id for states
dataS=[]; %panel data
dataEXO=[]; %exogenous regressors
dataStart=[];


for j=1:cols(statex)
    
    %construct 
    G1=gov_exp_pc(:,j)./GDPDEF;
    DG1=(G1-lagmatrix(G1,4))/4;  %approximate G-G(-1) average in a year
    Y=statex(:,j);
    DY1=Y-lagmatrix(Y,1);  %(Y-Y(-1)
    Y1=lagmatrix(Y,1);
    DG=DG1./Y1; %(G-G(-1)/Y(-1))
    DY=DY1./Y1; %(Y-Y(-1)/Y(-1))
    DE1=empx(:,j)-lagmatrix(empx(:,j),1);
    E1=lagmatrix(empx(:,j),1);
    DE=DE1./Y1; %(E-E(-1))/Y(-1)
    %DE=DE1./E1; %(E-E(-1))/E(-1)
    S1=exp(dataG(:,j)/100)./GDPDEF;
    DS1=S1-lagmatrix(S1,1);
    DS=DS1./Y1;
    
    
%     dat=[log(gov_exp_pc(:,j))*100-log(GDPDEF)*100 (log(statex(:,j)))*100 (log(empx(:,j)))*100];
%      START=[dataG(:,j)-log(GDPDEF)*100 ];
    dat=[DG DY DE]*100;
     START=DS(5:end,:)*100;
     dat=dat(5:end,:);
 
 %remove missing values
 idnan=isnan(dat(:,1));
 dat1=dat;
 dat1(idnan,1)=0;
 datP=packr([dat1 US idnan START]);
 datP1=datP(:,1:3);
 datE1=datP(:,4:end-2);
 idnan1=datP(:,end-1);
 datP1(idnan1==1,1)=nan;
  datS=datP(:,end:end);

  ind=repmat(j,rows(datP),1);

    index=[index;ind];
    dataS=[dataS;datP1];
    dataEXO=[dataEXO;datE1];
       dataStart=[dataStart;datS];

    
    
   [ j rows(datP)]

end
save('panelbenchmark_hall','dataS','index','dataEXO','dataStart');    
  [size(dataS)   size(dataEXO) size(index)]  
 data_1=[index dataS dataEXO dataStart];
 csvwrite('ms_data.csv','data_1');
 
    