
clear 
close all
clc
addpath('..\..\functions');

%% IRF ratio

% load IRFs in each regime
load irf1

% cumulate IRFs recession
irfy1 = (cumsum(irf(:,:,2),2));
irfg1 = (cumsum(irf(:,:,1),2));
mult1 = irfy1./irfg1;
load irf2

% cumulate IRFs boom
irfy2 = (cumsum(irf(:,:,2),2));
irfg2 = (cumsum(irf(:,:,1),2));
mult2 = irfy2./irfg2;

mults(:,:,1) = mult1;
mults(:,:,2) = mult2;




multsdiff=prctile(squeeze(mults(:,:,1)-mults(:,:,2)),[50 16 84]);



% pick horizons you want in quarters
ih = [4 8 12  20 40]; 

fprintf('\nGovernment spending multipliers\n');
fprintf('%10s %10s %10s \n','Horizon','Regime 1','Regime 2');
for i=1:numel(ih)
    fprintf('%10.3f %10.3f %10.3f \n',ih(i),median(mults(:,ih(i),1),1),...
        median(mults(:,ih(i),2),1));
end
fprintf('\n');






names{1}='Multiplier Recession';
names{2}='Multiplier Boom';
names{3}='Difference';

tmp=prctile(mults,[50 16 84]);
H=(1:40);
figure(1)
for j=1:2
ax(j) = subplot(1,3,j);
plotx2(H,tmp(:,H,j)');
title(names{j});
end
j=3;
ax(j) = subplot(1,3,j);
plotx2(H,multsdiff(:,H)');
title(names{j});
linkaxes(ax)



save('multipliers','mults');