 clear
clc
addpath('..\..\functions');
[~,names]=xlsread('..\..\data_2019\raw\statenames.xls');
for STATE=1:50
    fname1=strcat('.\STATEIRF\IRF1_STATE_',num2str(STATE));
    fname2=strcat('.\STATEIRF\IRF2_STATE_',num2str(STATE));
    load(fname1); mult1=mult;
    load(fname2); mult2=mult;
    sig1(:,:,STATE)=mult1-mult2;
    sig2(:,:,STATE)=(mult1-mult2)./mult2;
    sig11(:,:,STATE)=mult1;
    sig12(:,:,STATE)=mult2;
end
 sig1=prctile(sig1,[50 16 84]);
 sig2=prctile(sig2,[50 16 84]);
 sig11=prctile(sig11,[50 16 84]);
 sig12=prctile(sig12,[50 16 84]);

H=20;
tmp1=squeeze(sig1(1,H,:));
tmp2=squeeze(sig11(1,H,:));
tmp3=squeeze(sig12(1,H,:));

[~,id]=sort(tmp1(:,1));
%examine multiplier at a particular horizon
Hvec = [4 8 12 20 40];

%%
for kk=1:numel(Hvec)

    % H=20;
    H = Hvec(kk);

    tmp1=squeeze(sig1(:,H,:))';
    e1=tmp1(:,1)>0 & tmp1(:,2)>0; %pick out those states where multiplier greater in recessions using the 1 SD bands

    tmp2=squeeze(sig2(:,H,:))';
    e2=tmp2(:,1)>0 & tmp2(:,2)>0; %pick out those states where multiplier greater in recessions using the 1 SD bands

    tmp3=squeeze(sig11(:,H,:))';
    tmp4=squeeze(sig12(:,H,:))';

    %print
    fprintf('\n Difference in Government spending multipliers in recessions and booms\n');
    fprintf('%10s %10s %10s\n','States','Difference across regimes','1 if 0 not in Error band');
    for i=1:50
        fprintf('%10s %10.3f %10.3f\n',char(names{i}),[tmp1(i,1) e1(i,:)]);
    end
    fprintf('\n');

    if H==20; save('benchmark','tmp1'); end

    % write to text file, comma delimited and without heading, for stata
    filename = ['results_h' num2str(H,'%2g') '.txt'];
    fid = fopen(filename,'w');
    %fprintf(fid,'\n Difference in Government spending multipliers in recessions and booms\n');
    fprintf(fid,'%15s, %15s, %15s, %15s\n','STUSPS',...
        'mult_bust','mult_boom','diffdum');
    for i=1:50
        fprintf(fid,'%15s, %15.8f, %15.8f, %15.0f\n',...
            char(names{i}),[tmp3(i,1) tmp4(i,1) e1(i,:)]);
    end
    fclose(fid);

end


