
* This script reproduces Table 1 of the main paper and Columns 2-7 of Table 1 of the Technical Appendix
* ------------------------------------------------------------------------------


use xsection.dta, clear

* List of regressors
local reglist homevac min agr man loansh_9 tax empsh_10 


* ------------------------------------------------------------------------------
* Benchmark regression (Table 1 main paper)
reg pdmult_20 `reglist' regdum, robust


* ------------------------------------------------------------------------------
* Columns 2-7 of Table 1 in the Technical Appendix

* Column 2
reg mult_bust_20 `reglist' regdum, robust

* Column 3
reg mult_boom_20 `reglist' regdum, robust

* Column 4
local zreglist
* create standardized variables
foreach var of varlist `reglist' {
	egen z`var' = std(`var')
	local zreglist `zreglist' z`var'
}
* temporarily rename variables
foreach var of varlist `reglist' {
	rename `var' `var'_orig
	rename z`var' `var'
}
reg pdmult_20 `reglist' regdum, robust
* change variable names back
foreach var of varlist `reglist' {
	rename `var' z`var'
	rename `var'_orig `var'
}

* Column 5-7
reg pdmult_12 `reglist' regdum, robust
reg pdmult_8 `reglist' regdum, robust
reg pdmult_4 `reglist' regdum, robust


