

function [beta2,beta_tt]=carterkohn3(data,beta0,P00,R,F,Q,KK,floadr,exog,N,L,fload,state,Tbill)
T=rows(data);
NN=cols(data);
ns=cols(beta0);

%Carter and Kohn algorithm to draw the factor
beta_tt=zeros(T,ns);          %will hold the filtered state variable
ptt=zeros(T,ns,ns);    % will hold its variance
% %%%%%%%%%%%Step 6a run Kalman Filter
i=1;

floadrx=zeros(NN,1);
floadx=zeros(NN,KK);
for k=1:NN
floadrx(k,:)=squeeze(floadr(k,:,state(i,k)));
floadx(k,:)=squeeze(fload(k,:,state(i,k)));
end



H=zeros(NN+1,N*L);
H(1:NN,1:KK+1)=[floadx floadrx];
H(NN+1,KK+1)=1;
MU=[exog(i,:)';zeros(N*(L-1),1)]';


x=H;
%Prediction
beta10=MU+beta0*F';
p10=F*P00*F'+Q;
yhat=(x*(beta10)')';                                                
eta=[data(i,:) Tbill(i,:)]-yhat;
feta=(x*p10*x')+R;
%updating
K=(p10*x')*invpd(feta);
beta11=(beta10'+K*eta')';
p11=p10-K*(x*p10);
beta_tt(i,:)=beta11;
ptt(i,:,:)=p11;
for i=2:T
floadrx=zeros(NN,1);
floadx=zeros(NN,KK);
for k=1:NN
floadrx(k,:)=squeeze(floadr(k,:,state(i,k)));
floadx(k,:)=squeeze(fload(k,:,state(i,k)));
end



H=zeros(NN+1,N*L);
H(1:NN,1:KK+1)=[floadx floadrx];
H(NN+1,KK+1)=1;
x=H;
MU=[exog(i,:)';zeros(N*(L-1),1)]';
    %Prediction
beta10=MU+beta11*F';
p10=F*p11*F'+Q;
yhat=(x*(beta10)')';                                               
eta=[data(i,:) Tbill(i,:)]-yhat;
feta=(x*p10*x')+R;
%updating
K=(p10*x')*invpd(feta);
beta11=(beta10'+K*eta')';
p11=p10-K*(x*p10);
ptt(i,:,:)=p11;
beta_tt(i,:)=beta11;
end
% Backward recursion to calculate the mean and variance of the distribution of the state
%vector
beta2 = zeros(T,ns);   %this will hold the draw of the state variable
jv=1:KK; %index of state variables to extract
wa=randn(T,ns);
f=F(jv,:);
q=Q(jv,jv);
i=T;  %period t
p00=squeeze(ptt(i,jv,jv)); 
beta2(i,jv)=beta_tt(i:i,jv)+(wa(i:i,jv)*cholx(p00));   %draw for beta in period t from N(beta_tt,ptt)
%periods t-1..to .1
for i=T-1:-1:1
MU=[exog(i+1,:)';zeros(N*(L-1),1)]';
mu=MU(jv);

pt=squeeze(ptt(i,:,:));
% bm=beta_tt(i:i,:)+(pt*f'*inv(f*pt*f'+q)*(beta2(i+1:i+1,jv)-mu-beta_tt(i,:)*f')')';  
% pm=pt-pt*f'*inv(f*pt*f'+q)*f*pt;  
bm=beta_tt(i:i,:)+(pt*f'*invpd(f*pt*f'+q)*(beta2(i+1:i+1,jv)-mu-beta_tt(i,:)*f')')';  
pm=pt-pt*f'*invpd(f*pt*f'+q)*f*pt; 
beta2(i:i,jv)=bm(jv)+(wa(i:i,jv)*cholx(pm(jv,jv)));  

end
