function out=draw_data2(dataid0,beta0,P00,F,Q,EXO,mid)
%Carter and Kohn algorithm to draw the factor
nantype=check_missing_pattern(mid);
T=rows(dataid0);
N=cols(dataid0);
ns=cols(P00);
beta_tt=zeros(T,ns);          %will hold the filtered state variable
ptt=zeros(T,ns,ns);    % will hold its variance
% %%%%%%%%%%%Step 6a run Kalman Filter
beta11=beta0;
p11=P00;
for i=1:T
if nantype(i)~=0 %temporal aggregation and/or missing data
nanid=mid(i,1); %checks if data on G is missing
if nanid==1 %missing
 H=eye(N,ns);
 H(1,:)=0;
 rr=zeros(1,N);
 rr(1)=1e10;  %big variance so missing data ignored
 R=diag(rr);
else  %valid  observation for first variable every 3rd month
 H=eye(N,ns);
 tmp=repmat([1/4 zeros(1,N-1)],1,4);
 H(1,:)=tmp;
 rr=zeros(1,N);
 R=diag(rr);  
end   
else %all obs available nantype==0
H=eye(N,ns);
rr=zeros(1,N);
R=diag(rr);
end

x=H;
MUx=zeros(1,ns);
MUx(1:N)=EXO(i,:);
    %Prediction
beta10=MUx+beta11*F';
p10=F*p11*F'+Q;
yhat=(x*(beta10)')';                                               
eta=dataid0(i,:)-yhat;
feta=(x*p10*x')+R;
%updating
K=(p10*x')*invpd(feta);
beta11=(beta10'+K*eta')';
p11=p10-K*(x*p10);
ptt(i,:,:)=p11;
beta_tt(i,:)=beta11;
end
% Backward recursion to calculate the mean and variance of the distribution of the state
%vector
beta2 = zeros(T,ns);   %this will hold the draw of the state variable
bm2=beta2;
jv=1:N; %index of non singular block
jv1=1; %state variables to draw, 3, 5 are lagged states
i=T;  %period t
p00=squeeze(ptt(i,jv1,jv1)); 
beta2(i,:)=beta_tt(i,:);
beta2(i,jv1)=mvnrnd(beta_tt(i:i,jv1),p00,1);%beta_tt(i:i,jv1)+(wa(i:i,jv1)*cholx(p00));   %draw for beta in period t from N(beta_tt,ptt)
q=Q(jv,jv);
f=F(jv,:);
%periods t-1..to .1
for i=T-1:-1:1
MUx=zeros(1,ns);
MUx(1:N)=EXO(i+1,:); 
mu=MUx(jv);
pt=squeeze(ptt(i,:,:));
ifptfq=invpd(f*pt*f'+q);
bm=beta_tt(i:i,:)+(pt*f'*ifptfq*(beta2(i+1:i+1,jv)-mu-beta_tt(i,:)*f')')';  
pm=pt-pt*f'*ifptfq*f*pt;  
beta2(i,:)=bm;
beta2(i:i,jv1)=mvnrnd(bm(jv1),pm(jv1,jv1),1);     %bm(jv1)+(wa(i:i,jv1)*cholx(pm(jv1,jv1)));  
bm2(i,:)=bm;
end

out=beta2(:,1); %draw of Qrtly data