function [lik,beta_tt]=draw_data2_tar_lik(dataid0,beta0,P00,F1,F2,Q1,Q2,EXO1,EXO2,E1,mid)
%Carter and Kohn algorithm to draw the factor
T=rows(dataid0);
N=cols(dataid0);
ns=cols(P00);
beta_tt=zeros(T,ns);          %will hold the filtered state variable
ptt=zeros(T,ns,ns);    % will hold its variance
% %%%%%%%%%%%Step 6a run Kalman Filter
beta11=beta0;
p11=P00;
lik=0;
for i=1:T
     nanid=mid(i,1); %checks if data on G is missing

    if E1(i)==1
        F=F1;
        Q=Q1;
        MUx=zeros(1,ns);
     MUx(1:N)=EXO1(i,:);
    else
       F=F2;
        Q=Q2;
        MUx=zeros(1,ns);
     MUx(1:N)=EXO2(i,:);
    end
    
if nanid==1 %missing
 H=eye(N,ns);
 H(1,:)=0;
 rr=zeros(1,N);
 rr(1)=1e10;  %big variance so missing data ignored
 R=diag(rr);
else  %valid  observation for first variable every 3rd month
 H=eye(N,ns);
 tmp=repmat([1/4 zeros(1,N-1)],1,4);
 H(1,:)=tmp;
 rr=zeros(1,N);
 R=diag(rr);  
end   


x=H;
    %Prediction
beta10=MUx+beta11*F';
p10=F*p11*F'+Q;
yhat=(x*(beta10)')';                                               
eta=dataid0(i,:)-yhat;
feta=(x*p10*x')+R;
ifeta=invpd(feta);
%updating
K=(p10*x')*invpd(feta);
beta11=(beta10'+K*eta')';
p11=p10-K*(x*p10);
ptt(i,:,:)=p11;
beta_tt(i,:)=beta11;
%lik
liki=-0.5*log(2*pi)-0.5*log(det(feta))+(-0.5*(eta)*ifeta*(eta'));

if isreal(liki) && (~isinf(liki))
    lik=lik+liki;
else
    lik=lik-10;
end
end



end
