function yhat = ...
    get_pathsTVAR(N, HORZ, T, L, Y, beta1, sigma1,beta2,sigma2,tar,tvar,delay,EXO,Le,Lt)
% -------------------------------------------------------------------------
% get_paths:
% generates a matrix of simulated paths for Y for given parameters and
% general set-up (lags, horizon, etc.)
% -------------------------------------------------------------------------


% Draw N(0,1) innovations for variance and mean equation:
csigma1=chol(sigma1);
csigma2=chol(sigma2);
Lx=max([L Le Lt+delay]);

uu1 = randn(HORZ+Lx,N);
uu2 = randn(HORZ+Lx,N);
% Note we only need HORZ*N innovations, but adding an extra L draws makes 
% the indexing in the loop below a bit cleaner.
%compute forecast
yhat=zeros(HORZ+Lx,N);
yhat(1:Lx,:)=Y(T-Lx+1:T,:);
ystar=zeros(HORZ+Lx,1);
exomat=EXO(T-Lx+1:T,:);
for fi=Lx+1:HORZ+Lx
    
    xhat=[];
    for ji=1:L
        xhat=[xhat yhat(fi-ji,:)];
    end
     for ji=1:Le
        xhat=[xhat exomat((Lx+1)-ji,:)];
    end 
    
    xhat=[xhat 1];
    tmp=yhat(fi-delay,tvar);
    for ji=1:Lt-1
        tmp=tmp+yhat(fi-delay-ji,tvar);
    end
    ystar(fi,:)=tmp;
    
    e1=ystar(fi,:)<=tar;
    e2=ystar(fi,:)>tar;
    %[e1 e2]
    yhat(fi,:) = ((xhat*beta1 + uu1(fi,:)*csigma1)*e1)+...
        ((xhat*beta2 + uu2(fi,:)*csigma2)*e2);
    
end
yhat=yhat(Lx+1:end,:);
