function yhat = ...
    get_pathsVAR(N, HORZ, T, L, Y, beta1, sigma1,EXO,Le)
% -------------------------------------------------------------------------
% get_paths:
% generates a matrix of simulated paths for Y for given parameters and
% general set-up (lags, horizon, etc.)
% -------------------------------------------------------------------------


% Draw N(0,1) innovations for variance and mean equation:
csigma1=chol(sigma1);
Lx=max([L Le]);

uu1 = randn(HORZ+Lx,N);
uu2 = randn(HORZ+Lx,N);
% Note we only need HORZ*N innovations, but adding an extra L draws makes 
% the indexing in the loop below a bit cleaner.
%compute forecast
yhat=zeros(HORZ+Lx,N);
yhat(1:Lx,:)=Y(T-Lx+1:T,:);
exomat=EXO(T-Lx+1:T,:);
for fi=Lx+1:HORZ+Lx
    
    xhat=[];
    for ji=1:L
        xhat=[xhat yhat(fi-ji,:)];
    end
     for ji=1:Le
        xhat=[xhat exomat((Lx+1)-ji,:)];
    end 
    
    xhat=[xhat 1];
   
    
   
    yhat(fi,:) = ((xhat*beta1 + uu1(fi,:)*csigma1));
    
end
yhat=yhat(Lx+1:end,:);
