function [saveirf1,saveirf1L]= getirf1S_order(STATE,sfolder,ngibbs)
file=1;

fnamex=strcat(sfolder,'results',num2str(file));
fnamep=strcat(sfolder,'priors');
sfile='irf1'; %name of file to save results

load(fnamex)
load(fnamep);

fsize=ngibbs;  %number of Gibbs replications
reps=50; %number of monte-carlo replications
tarvar=3; %position of threshold variable in endogenous variables of VAR
horizon=40; %horizon
scale=1; %scale of shock
normalise=1; %if normalise==1, shock is set to scale, else shock=scale*shock standard dev
prob=0.8;  %recession  if F(z)>prob, boom if F(z)<1-prob


%To intialise IRF use  data for states
dat=Y(index==id(STATE),:);%nanmean(dat,3);
ddat=diff(dat);%nanmean(ddat,3);
ddat=[ddat(1,:);ddat];
%max lags
L=L;
av=av;
GAMMA=GAMMA;
  LL=max([L,av+2]);
  T=rows(dat);
  
%threshold variable
tmpx=movav(ddat(:,tarvar),av);
 ystardat=lag0(tmpx,1);
 ystardat=packr(ystardat);
ystardat=[ystardat(1:av+1,:);ystardat];
tmean=nanmean(ystardat); %mean
tstd=nanstd(ystardat); %stdev
[ss,tmpxx]=transfun2(ystardat,GAMMA); %F(z)

%construct history (i.e. all possible starting values for the endogenous
%variables)
dathistory=zeros(LL,N,T-LL); %data
ddathistory=zeros(LL,N,T-LL); %first difference
ystarhistory=zeros(LL,1,T-LL); %z
for i=LL+1:T
   dathistory(:,:,i)=dat(i-LL+1:i,:); 
   ddathistory(:,:,i)=ddat(i-LL+1:i,:); 
   ystarhistory(:,:,i)=ystardat(i-LL+1:i,:); 
end
for i=1:LL
   dathistory(:,:,i)=dat(1:LL,:); 
   ddathistory(:,:,i)=ddat(1:LL,:); 
   ystarhistory(:,:,i)=ystardat(1:LL,:); 
end
 %divide sample
   e1=ss;
   e2=1-ss;
   dat1=dathistory(:,:,e1>(prob));
   ddat1=ddathistory(:,:,e1>(prob));
   ystar1=ystarhistory(:,:,e1>(prob));
   T1=size(dat1,3);
saveirf1=zeros(fsize,horizon,N);
saveirf1L=saveirf1;
for mm=1:fsize
   

alphabar1=squeeze(bsave1(mm,id(STATE),:));
alphabar2=squeeze(bsave2(mm,id(STATE),:));%=alphabar2';
c1=(squeeze(csave1(mm,id(STATE),:)))';
c2=(squeeze(csave2(mm,id(STATE),:)))';
h1=(squeeze(hsave1(mm,id(STATE),:)));
h2=(squeeze(hsave2(mm,id(STATE),:)));
 Abar1=chofac(N,squeeze(Asave1(mm,id(STATE),:)));%=Abar1';%=zeros(fsize,NA0);
Abar2=chofac(N,squeeze(Asave2(mm,id(STATE),:)));%=Abar2';%=zeros(fsize,NA0);           
sig1=invpd(Abar1)*diag(h1)*invpd(Abar1)';
sig2=invpd(Abar2)*diag(h2)*invpd(Abar2)';


b1=reshape(alphabar1,N*L+EX,N); 
b2=reshape(alphabar2,N*L+EX,N);
  %recession regime
  xirf1=0;
  xirf2=0;
 
  parfor tt=1:T1 %loop across all possible starting values in this regime
      y0=dat1(:,:,tt);
       dy0=ddat1(:,:,tt);
        ystar0=ystar1(:,:,tt);
  %irf  defense spending*
  pos=4; %shock to equation pos
  [irf1,yhat1,yhat,p1,p,dyy,yy,yss1,yss,irf1L]=...
      getirfmcnewN(b1,b2,c1,c2,L,reps,y0,horizon,av,tmean,tstd,sig1,sig2,scale,pos,GAMMA,tarvar,normalise,dy0,ystar0);

   [mm tt STATE]
  
  xirf1=xirf1+irf1;
  xirf2=xirf2+irf1L;
  end
  xirf1=xirf1./(T1); %average response in this regime
  xirf2=xirf2./(T1); %average response in this regime in levels
 

  


            
saveirf1(mm,:,:)=xirf1;
saveirf1L(mm,:,:)=xirf2;

            

end

end