function [irf,yhat1,yhat,p1,p,dyhat1,dyhat,yss1,yss,irfL]=...
    getirfmcnewN(b1,b2,c1,c2,L,reps,y0,horizon,av,prc,sigmaz,sigma1,sigma2,scale,pos,theta,tarvar,norm,dy0,ystar0)

yhat1=0;%E(Y|shock)
yhat=0; %E(Y)
dyhat1=0;%E(dY|shock)
dyhat=0;%E(dY)
yhatL1=0; %E(exp(Y/100)|shock); convert to levels. To get response of Y and G
yhatL=0; %E(exp(Y/100))
p1=0;
p=0;
yss1=0;
yss=0;
LL=max([L,av+2]);
N=cols(y0);
A1=chol(sigma1);
A2=chol(sigma2);

if norm==1 %normalise chol decomp if required (for period of shock)
 tmp1=chol(sigma1);
 A01=tmp1./repmat(diag(tmp1),1,N);
  tmp2=chol(sigma2);
 A02=tmp2./repmat(diag(tmp2),1,N);
else
    A01=A1;
    A02=A2;
end

for j=1:reps
    %initialise
    px1=zeros(horizon+LL,1);
    px=zeros(horizon+LL,1);
        ystar=zeros(horizon+LL,1);
        ystar(1:LL,:)=ystar0; %z
    ystars=ystar; %z|shock
    ymat=zeros(horizon+LL,N);

    ymat(1:LL,:)=y0; %y
    ymats=ymat; %y|shock
      dymat=zeros(horizon+LL,N);
    dymat(1:LL,:)=dy0; %diff(y)
    dymats=dymat;%diff(y)\shock
  
    resids=randn(horizon+LL,N); %VAR resids
    %simulate

    for t=LL+1:horizon+LL
    
   
  
    ss=(exp(-theta*((ystar(t-1)-prc)/sigmaz)))./(1+exp(-theta*((ystar(t-1)-prc)/sigmaz))); %F(z)

    sss=(exp(-theta*((ystars(t-1)-prc)/sigmaz)))./(1+exp(-theta*((ystars(t-1)-prc)/sigmaz))); %F(z)|shock
    
    %simulate base case (i.e. no shock)
    xmat=[];
    for i=1:L
        xmat=[xmat ymat(t-i,:)];
    end
    

    %simulate shock case
    xmats=[];
    for i=1:L
        xmats=[xmats ymats(t-i,:)];
    end
     

    
   if t==LL+1 %shock occurs
    shock=zeros(1,N);
    shock(1,pos)=scale;
    
    ymats(t,:)=((c1+xmats*b1).*sss)+((c2+xmats*b2).*(1-sss))+((shock*A01).*sss)+((shock*A02).*(1-sss));

    ymat(t,:)=((c1+xmat*b1).*ss)+((c2+xmat*b2).*(1-ss));%baseline
     
   else %all other periods
       
  ymats(t,:)=((c1+xmats*b1).*sss)+((c2+xmats*b2).*(1-sss))+((resids(t,:)*A1).*sss)+((resids(t,:)*A2).*(1-sss));

   ymat(t,:)=((c1+xmat*b1).*ss)+((c2+xmat*b2).*(1-ss))+((resids(t,:)*A1).*ss)+((resids(t,:)*A2).*(1-ss));

    
   end
    
   %growth rates
   dymat(t,:)=ymat(t,:)-ymat(t-1,:);
     dymats(t,:)=ymats(t,:)-ymats(t-1,:);
     
     %construct Z (moving average of order av of growth rates)
     fz=dymat(t,tarvar);
     fzs=dymats(t,tarvar);
      for i=1:av
          fz=fz+dymat(t-i,tarvar);
          fzs=fzs+dymats(t-i,tarvar);
      end
        fz=fz/(av+1);
      fzs=fzs/(av+1);
      ystar(t,:)=fz;
      ystars(t,:)=fzs;
   
   
    px(t,:)=ss;
    px1(t,:)=sss;
    
    end
    
    yhat=yhat+ymat;
    yhat1=yhat1+ymats;
    
    yhatL1=yhatL1+exp(ymats/100);
    yhatL=yhatL+exp(ymat/100);
    
    p=p+px;
    p1=p1+px1;
    yss1=yss1+ystars;
        yss=yss+ystar;

      dyhat=dyhat+dymat;
    dyhat1=dyhat1+dymats;
    
end
% dymat
yhat=yhat./reps;%E(Y)
yhat1=yhat1./reps;%E(Y|shock)
yhatL=yhatL./reps;%E(exp(Y/100))
yhatL1=yhatL1./reps;%E(exp(Y/100)|shock)
p=p./reps;
p1=p1./reps;
dyhat=dyhat./reps;
dyhat1=dyhat1./reps;
yss1=yss1/reps;
yss=yss/reps;
irf=yhat1-yhat; %E(Y|shock)-E(Y)
irf=irf(LL+1:end,:);
irfL=yhatL1-yhatL;
irfL=irfL(LL+1:end,:);
    