function [post,lik,prior]=getposteriorA(theta,NA0,N,resids,E1,E2,Abar1,Abar2,vbar,lamda1,lamda2,thetaH)


    [sigma1,sigma2,a1,a2,h1,h2] = createsigma( [theta thetaH],NA0,N );
    %evaluate priors
priorA1=multivariatenormal(a1',Abar1',lamda1*vbar);
priorA2=multivariatenormal(a2',Abar2',lamda2*vbar);

prior=priorA1+priorA2;
if isnan(prior) || isinf(prior) || ~isreal(prior)
  post=-inf;
    lik=-inf;
  
    return;
else
    
 %calculate likelihood via a Kalman filter
 
 H=eye(N);
 B00=resids(1,:);
 P00=eye(cols(B00));

[lik,beta_tt,ptt]=kalmafiltervar(resids,H,sigma1,sigma2,B00,P00,E1,E2);
% tic;
% [likx,beta_ttx,pttx]=kalmafiltervarF(resids,H,sigma1,sigma2,B00,P00,E1,E2);
% toc;
% num2str([lik likx])

post=lik+prior;
if isnan(post) || isinf(post) || ~isreal(post)
  post=-inf;
    lik=-inf;
    
 
    return
end
end
