function [post,lik,prior]=getposteriorHL(thetain,NA0,N,resids,E1,E2,H0,vH0,thetaA)

theta=exp(thetain); %draw is in logs
 [sigma1,sigma2,a1,a2,h1,h2] = createsigma( [thetaA theta],NA0,N );
    %evaluate priors

priorH1=0;
priorH2=0;
for j=1:length(h1)
  priorH1=priorH1+gampdf1(vH0,H0,1/h1(j));
   priorH2=priorH2+gampdf1(vH0,H0,1/h2(j));
end

prior=priorH1+priorH2;
if isnan(prior) || isinf(prior) || ~isreal(prior)
  post=-inf;
    lik=-inf;
  
    return;
else
    
 %calculate likelihood via a Kalman filter
 
 H=eye(N);
 B00=resids(1,:);
 P00=eye(cols(B00));

[lik,beta_tt,ptt]=kalmafiltervar(resids,H,sigma1,sigma2,B00,P00,E1,E2);
% tic;
% [likx,beta_ttx,pttx]=kalmafiltervarF(resids,H,sigma1,sigma2,B00,P00,E1,E2);
% toc;
% num2str([lik likx])

post=lik+prior;
if isnan(post) || isinf(post) || ~isreal(post)
  post=-inf;
    lik=-inf;
    
 
    return
end
end
