function[lik,beta_tt,ptt]=kalmafiltervar(Y,H,sigma1,sigma2,beta0,P00,E1,E2)
T=rows(Y);

%%Step 2a Set up matrices for the Kalman Filter

ns=cols(beta0);

beta_tt=zeros(T,ns);          %will hold the filtered state variable
ptt=zeros(T,ns,ns);    % will hold its variance
beta11=beta0;
p11=P00;
F=zeros(ns);
mu=0;
R=0;
% %%%%%%%%%%%Step 2b run Kalman Filter
lik=0;
for i=1:T
   x=H;
Q=(sigma1.*E1(i))+(sigma2.*E2(i));
    %Prediction
beta10=mu+beta11*F';
p10=F*p11*F'+Q;
yhat=(x*(beta10)')';                                               
eta=Y(i,:)-yhat;
feta=(x*p10*x')+R;
if rcond(feta)<1e-14
lik=-inf;
return
end
ifeta=invpd(feta);
%updating
K=(p10*x')*ifeta;
beta11=(beta10'+K*eta')';
p11=p10-K*(x*p10);

ptt(i,:,:)=p11;
beta_tt(i,:)=beta11;
liki=-0.5*log(2*pi)-0.5*log(det(feta))+(-0.5*(eta)*ifeta*(eta'));

if isreal(liki) && (~isinf(liki))
    lik=lik+liki;
else
    lik=lik-10;
end

end

