
function [beta,BB,W,problem]=...
    pftest9Fr(F1,F2,EXO1,EXO2,iQ1,iQ2,cQ1,cQ2,xfix,y,NS,B00,N,Nx,mid1,mid2)
%

T=size(y,1);
problem=zeros(T,1);
nantype=check_missing_pattern(mid2);

beta=zeros(T,NS,N); %will hold filtered state variable
beta(1,:,:)=repmat(B00',1,N); %fixed initial condition
BB=zeros(N,T); %ancestor indices 
W=zeros(N,T); %weights
beta(1,:,N)=xfix(1,:);
for t=1:T
      fit1=[EXO1(t,:) zeros(1,NS-Nx)]; 
      fit2=[EXO2(t,:) zeros(1,NS-Nx)]; 


if (t~=1)
    index=discretesample(W(:,t-1),N);
    index=index(randperm(N));
     %threshold
     growth1=beta(t-1,2,:)-beta(t-1,2+Nx,:); %D(Y(t-1))
     growth2=beta(t-1,2+Nx,:)-beta(t-1,2+Nx*2,:); %D(Y(t-2))
     e1=growth1<0 & growth2<0;
    
    [betahat,m]=xpred(beta(t-1,:,:),F1,F2,fit1,fit2,xfix(t,:),iQ1,iQ2,e1);
    
   %draw particles
    for j=1:N
    e1j=e1(:,:,j);
    e2j=1-e1j;
    beta(t,:,j)=betahat(:,:,index(j))+((randn(1,NS)*cQ1).*e1j)+...
        ((randn(1,NS)*cQ2).*e2j);
    end
     
    
    %conditioned particle
    beta(t,:,N)=xfix(t,:);
    %sample ancestors
    was=m.*W(:,t-1);
    probas=was./sum(was);
    if sum(was)==0 || any(isnan(probas))
       problem(t)=1;
       index(N)=1;
   else
    index(N)=discretesample(probas,1);%find(rand(1) < cumsum(probas),1,'first');%discretesample(probas,1);
    end
    BB(:,t)=index';
end

%H Matrix
nanid1=mid1(t,1); %checks if data on G is missing
nanid2=mid2(t,1);%checks if data on Y is missing
H=eye(Nx,NS);
rr=ones(1,Nx).*0.1;
id=zeros(1,Nx);
if nanid1==1 %missing G
 H(1,:)=0;
 rr(1)=1e20;  %big variance so missing data ignored
 id(1)=1;
elseif nanid1==0  %valid  observation for first variable every 3rd month
 tmp=repmat([1/4 zeros(1,Nx-1)],1,4);
 H(1,1:cols(tmp))=tmp;
end   
if nantype(t)~=0
if nanid2==1 %missing Y
 H(2,:)=0;
 rr(2)=1e20;  %big variance so missing data ignored
 id(2)=1;
elseif nanid2==0  %valid  observation for first variable every 3rd month
 tmp=repmat([0 1/4 zeros(1,Nx-2)],1,4);
 H(2,1:cols(tmp))=tmp;
end   
end

ldetR=sum(log(rr(id==0)));
iR=diag(1./rr(id==0));
%compute importance weights
logweights=zeros(1,N);
for j=1:N
beta1=(beta(t,:,j)); %[states]
res=y(t,:)-(H*beta1')';
%[res(:,id==0) nanid1 nanid2]
res2=res(:,id==0)*iR*res(:,id==0)';
logweights(j)=-0.5*ldetR+(-0.5*res2);%logweights(j)=log((1/sqrt(detR)))+(-0.5*res2);


end
const = max(logweights); % Subtract the maximum value for numerical stability
weights = exp(logweights-const);
W(:,t)=weights./sum(weights);

%logweights
end


% Generate the trajectories from ancestor indices
index = BB(:,T);
for t = T-1:-1:1
    beta(t,:,:) = beta(t,:,index);
    index = BB(index,t);
end
end
%xpred(beta(t-1,:,:),F1,F2,fit1,fit2,xfix(t,:),iQ1,iQ2,e1);
function [out,dens]= xpred(beta,F1,F2,fit1,fit2,x,iQ1,iQ2,E1)
N=size(beta,3);
NS=size(beta,2);
out=zeros(1,NS,N);
dens=zeros(N,1);
mu1=zeros(1,NS);
mu1(:,1:cols(fit1))=fit1;
mu2=zeros(1,NS);
mu2(:,1:cols(fit2))=fit2;
for j=1:N
 e1=E1(:,:,j);
 if e1==1
 fitx= (beta(:,:,j))*F1'+mu1;
 res=fitx-x;
 densx=exp(-0.5*res*iQ1*res');
 else
  fitx= (beta(:,:,j))*F2'+mu2;
 res=fitx-x;
 densx=exp(-0.5*res*iQ2*res');
 end
 
 
 %squeeze(betahat(:,:,index))'+randn(N,NS)'*cQ
out(:,:,j)=fitx;
dens(j,:)=densx;
end

end

