function datamedian=runMFVAR(dataid,id)
data=dataid;
data(:,1)=fill_nearest(dataid(:,1));
mid=isnan(dataid(:,1));  %id for missing obs
dataid0=dataid;
dataid0(mid,1)=0;

N=cols(data);
REPS=10000;
BURN=5000;
SKIP=5;
maxtrys=100;
Sindex=BURN+1:SKIP:REPS;
fsize=length(Sindex);

L=4;  %lags
TREND=2;
Y=data;
[X,EX]=prepare22(data,L,TREND); %X=[Y(-1),Y(-2)...constant]
Y=Y(L+1:end,:);
X=X(L+1:end,:);
X00=X;
dataid0=dataid0(L+1:end,:);
dataid=dataid(L+1:end,:);
dataM=dataid0(:,2:end);
mid=mid(L+1:end,:);


T=rows(X);

%initial values for VAR coefficients

b0=X\Y;  %ols
e0=Y-X*b0;
sigma=(e0'*e0)/(T-cols(X));
a0=chol(sigma);
a1=invpd(a0./repmat(diag(a0),1,N))';
H1=diag(a1*sigma*a1');
varcoef0=vec(b0);

%priors for VAR coefficients (Banbura et.al)
LAMDAP=0.1;
EPSILONP=1/100;
[yd,xd]=getdummiesEXO(Y,LAMDAP,EPSILONP,L,EX);
%priors for off-diagonals
A00=a1(:);
A00(A00==1 | A00==0)=[];
VA0=ones((N*(N-1))/2,1)*100;
%priors for variance
H0=H1;
VH0=ones(N,1).*100;
VH0(1)=0.1;
S0h=2*H0.*(1+(H0.^2)./(VH0.^2));
NU0h=2*(2+(H0.^2)./(VH0.^2));



%Initial values for the Kalman filter B0/0
beta0=[];
for j=0:L-1
    beta0=[beta0 Y(L-j,:)];
end
P00=eye(cols(beta0))*0.1;  %P[0/0]

datasave=zeros(fsize,T);
% Gibbs sampler
gibbs1=1;
for gibbs=1:REPS



%step 1 Draw VAR coefficients  
X0=[X;xd]; %add dummy obs
Y0=[Y;yd];
mstar=vec(X0\Y0);
vstar=kron(sigma,invpd(X0'*X0));
cvstar=chol(vstar);
trys=1;
chck=-1;
while chck<0 && trys<=maxtrys
varcoef=mstar+(randn(1,N*(N*L+EX))*cvstar)'; %draw but keep stable
ee=stabilityxxx(varcoef,N,L,EX);
if ee==0
    chck=1;
else
    trys=trys+1;
end
end
if chck<0
    varcoef=varcoef0;
else
    varcoef0=varcoef;
end


%step 2 Draw VAR covariance
varcoefx=reshape(varcoef,N*L+EX,N);
 resids=Y-X*varcoefx;
  [iA1,A1]=getamatonly(resids,H1,A00,VA0,N);
  eps1=resids*chofac(N,A1')';
  for jj=1:N
      H1(jj)=drawsigma(NU0h(jj),S0h(jj),eps1(:,jj));
  end
  sigma=iA1*diag(H1)*iA1';

%step 3 Carter Kohn algorithm  to draw quarterly data

F=comp(varcoef,N,L,EX); %companion form for coefficients
EXO=X00(:,N*L+1:end)*varcoefx(N*L+1:end,:);
ns=cols(F);
Q=zeros(ns,ns);
Q(1:N,1:N)=sigma; %companion form for covariance
out=draw_data1(dataid0,beta0,P00,F,Q,EXO,mid); 
datax=[out dataM];
Y=datax;
X=prepare22(Y,L,TREND);
Y=Y(L+1:end,:);
X=X(L+1:end,:);



 if rem(gibbs,1000)==0   
fprintf('Iteration Number= %s \n', num2str([gibbs id]));
 end
if gibbs>=BURN
if sum(Sindex==gibbs)>0
datasave(gibbs1,:)=out';
gibbs1=gibbs1+1; 
end
end

end

datamedian=prctile(datasave,50,1);

 